// dynaloadvcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dynaloadvc.h"
#include "dynaloadvcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDynaloadvcDlg dialog

CDynaloadvcDlg::CDynaloadvcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDynaloadvcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDynaloadvcDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_lpVitamin = NULL;
}

void CDynaloadvcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDynaloadvcDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDynaloadvcDlg, CDialog)
	//{{AFX_MSG_MAP(CDynaloadvcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LOAD, OnButtonLoad)
	ON_BN_CLICKED(IDC_BUTTON_UNLOAD, OnButtonUnload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDynaloadvcDlg message handlers

BOOL CDynaloadvcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDynaloadvcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDynaloadvcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDynaloadvcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDynaloadvcDlg::OnButtonLoad() 
{
	CWaitCursor wc;
	if (m_lpVitamin == NULL)
	{
		// TODO: Add your control notification handler code her
		m_lpVitamin = (CVitaminCtrl*)new CVitaminCtrl();
		m_lpVitamin->Create("test",WS_CHILD|WS_VISIBLE,CRect(3,3,200,200),this,10001);
		m_lpVitamin->SetAutoServerModelType(TRUE);

		m_lpVitamin->SetUserName("root");
		m_lpVitamin->SetPassword("123");
		m_lpVitamin->SetRemoteIPAddr("192.168.1.240");
		m_lpVitamin->SetCurrentControlCam(1);
		m_lpVitamin->Connect();	
	}
}

void CDynaloadvcDlg::OnButtonUnload() 
{
	CWaitCursor wc;

	if (m_lpVitamin)
	{
		m_lpVitamin->CloseConnect();	
		delete m_lpVitamin;
		m_lpVitamin = NULL;
	}
}

BEGIN_EVENTSINK_MAP(CDynaloadvcDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CDynaloadvcDlg)
	ON_EVENT_RANGE(CDynaloadvcDlg, 10001, 20000, 9 /* OnNewVideo */, OnNewImage, VTS_I4 VTS_BOOL VTS_BOOL VTS_PVARIANT)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

// this function could catch all the onNewVideo event for vitaminctrl with ID from 10001 to 20000
void CDynaloadvcDlg::OnNewImage(UINT nID, BOOL bSignal, BOOL bDecodedImg, VARIANT FAR* vPiece) 
{
	// TODO: Add your control notification handler code here
	TRACE("Begin newVitamin OnNewVideo! nID=%d\n",nID);	
}
